/* selbstgeschriebener Header Butobin.h zum umwandeln von Buchstaben in
Binrzahlen, dargestellt in einem String. */
#ifndef butobin
#define butobin 1

void buzubin(unsigned int letter,  char wort[]);   // unsigned char (*wort)[]);
void binzuza(unsigned int *letter, unsigned char wort[]);
void BIZUDE(unsigned char wort[], long int *dewer);
//#ifdef __cplusplus
//void DEZUBI( long zahl, unsigned char zudi[], short ShowPreZero = 0);
//#else
//void DEZUBI(long int zahl, unsigned char zudi[]);
//#endif



/* -----------------------------------------------------------------------
 * Die Funktion buzubin wandelt den als int-Wert gegebenen Parameter 1
 * in einem Binrwert vom Typ BYTE um. Dieser wird in Parameter 2 als
 * String gespeichert. Es werden dabei immer 8 Stellen des Binrwertes
 * gezeigt. Das neunte Byte im String dient zur String-Terminierung.
 *Aufruf:  buzubin( Char-Wert_als_int, &Binrwert_als_String); 
 */

void buzubin(unsigned int letter, char wort[])
{
unsigned int slei, dum, testwert;

 /* Ininitalisert die 8 Binrstellen mit Null */
 for (slei = 0; slei <= 11; slei++)
  wort[8] = '\0';
     
 for (slei = 0; slei <= 7; slei++)
  {              
   testwert = 128 >> slei;  /* Bit7(128dez) ist auf Char-Nr.0 */
   dum = letter & testwert;
   if (dum != 0)  wort[slei] = '1';
    else          wort[slei] = '0';
  }
}

/* Die Funktion binzuza wandelt Binrwerte die als Strings gespeichert sind,
 * in Dezimalzahlen um. Die erste Schleife dient zum feststellen der Stringlaenge
 * ----------------------------------------------------------------------- */
void binzuza(unsigned int (*letter), unsigned char wort[])
{
unsigned int slei, ende, dumsm, dumza = 0, testwert = 1;
 
 for (ende = 0; ende <= 8; ende++)
  if (wort[ende] == '\0') break;
  
 testwert<<= (ende - 1); /* Anpassung von testwert an Stringlaenge */
 
 for (slei = 0; slei <= (ende - 1); slei++)
  if ((wort[slei] == 'I') || (wort[slei] == '1'))
   {
    dumsm = testwert >> slei;
    dumza += dumsm;
   } 
 (*letter) = dumza;
}

/* ----------------------------------------------------------------------- */
#ifdef __cplusplus
void DEZUBI( unsigned long zahl, char zudi[], short ShowPreZero = 0, short Bytelaenge = 4)
{
char wort[35], worz[35];
int slei, sleib, startbit = 31;
unsigned long dum2, testwert, kon = 1;

for (slei = 0; slei <= 34; slei++)                                                        
wort[slei] = worz[slei] = '\0';                                                           

if (Bytelaenge == 1) startbit = 7;
if (Bytelaenge == 2) startbit = 15;

kon <<= startbit ;  
  
for (slei = 0; slei <= startbit; slei++)
  {              
   testwert = kon >> slei;  /* Bit30(1073741824dez) ist auf Char-Nr.0 */
   dum2 = zahl & testwert;
   if (dum2)  wort[slei] = '1';
    else     wort[slei] = '0';
  }
 
for (slei = 0; slei <= startbit; slei++)
if (wort[slei] == '1') break;

 for (sleib = 0; sleib <= (startbit + 1); sleib++)
        {
         worz[sleib] = wort[slei];
         if (wort[slei] == '\0')
          break;
         slei++;
        }
 for (slei = 0; slei <= (startbit + 1); slei++)
  if ( ShowPreZero == 0)
   zudi[slei] = worz[slei]; /* wenn ShowPreZero == 0 dann ohne Vornullen */
    else 
     zudi[slei] = wort[slei];
}           

#else
/* Diese Funktion ist nach der Umstellung auf Shiftoperation in der Bitprobe noch nicht getestet (23.06.2006) */
void DEZUBI( unsigned long zahl, char zudi[])                                                    /*22:16 */
{
char wort[35], worz[35];
int slei, sleib;
unsigned long dum2, testwert, kon = 1;

for (slei = 0; slei <= 34; slei++)                                                        
wort[slei] = worz[slei] = '\0';                                                           

kon <<= 31 ; 
  
for (slei = 0; slei <= 31; slei++)
  {              
   testwert = kon >> slei;  /* Bit30(1073741824dez) ist auf Char-Nr.0 */
   dum2 = zahl & testwert;
   if (dum2)  wort[slei] = '1';
    else     wort[slei] = '0';
  }
 
for (slei = 0; slei <= 31; slei++)
if (wort[slei] == '1') break;

 for (sleib = 0; sleib <= 32; sleib++)
        {
         worz[sleib] = wort[slei];
         if (wort[slei] == '\0')
          break;
         slei++;
        }

 for (slei = 0; slei <= 32; slei++)
  zudi[slei] = worz[slei]; /* ohne Vornullen */
}
#endif
/* ----------------------------------------------------------------------- */
void BIZUDE(unsigned char wort[], long int (*dewer) )
{
int slei;
long ende, testwert = 1, dumsm, dumza = 0;
 
 for (ende = 0; ende <= 32; ende++)
  if ((wort[ende] == 32) || (wort[ende] == '\0')) break;
  
 testwert<<= (ende - 1); /* Anpassung von testwert an Stringlaenge */
 
 for (slei = 0; slei <= (ende - 1); slei++)
  if ((wort[slei] == 'I') || (wort[slei] == '1'))
   {
    dumsm = testwert >> slei;
    dumza += dumsm;
   } 
(*dewer) = dumza;
}
/*  Diese Funktion zhlt wieviel bits eines Bytes auf null bzw. auf
 *  eins gesetzt ist und schreibt sie in die jeweiligen Patameter:
 *  low = Parameter 2, high=parameter 3 */
void tellybin(int letter, long (*oinsa), long (*nulla))
{
int grot[8] = { 128, 64, 32, 16, 8, 4, 2, 1 };
int slei, dum1, dum2, dum3;
 dum2 = dum3 = 0;
 dum1 = letter;
 
for (slei = 0; slei <= 7; slei++)
 {
  dum2 = dum1 / grot[slei];
  if (dum2 == 1)
   {
   dum1 -= grot[slei];
   dum3 += 1;
   }
  }
(*oinsa) = dum3;
(*nulla) = 8 - dum3;
}

#endif

