/***-----
| Talarius.cpp
|
| Demonstriert wie ganzzahlige Zufallszahlen generiert und abgespeichert werden.
|
| Im Programm darf rand() nur einmal pro Laufzeit aufgerufen werden, sonst werden
| immer nur die gleichen Zahlen generiert.  Das  Schlüssel-Areal  dient  dazu  zu
| zeigen, wie eine Anzahl von Zufallszahlen erzeugt wird, in der  jede  Zahl  von
| Null bis zur Obergrenze nur einmal vorkommt.
|
-----***/

#include <iostream>
#include <stdlib.h>
#include <stdio.h> // wegen fopen
#include <fcntl.h>  // wegen open
#include <errno.h>  // wegen errno
#include <unistd.h> // wegen close
#include "getch.h"
#include "dos_fcntl.h"
#include "talarius.h"
#include <string.h>

using namespace std;

int main (void)
{
 Talarius taurus;
 int wohin = 12;   //, toprange;
 int iskeyfile = 0;
 int ausis = 0;
 long kfilen = 0L;
 long erge = 0L;
 int mslei = 0, dummy;
 int intlenge = 0;
 //toprange = taurus.gettoprange();

 intlenge = sizeof(int);

 if (intlenge < 4)
  {
   cout << "Länge des Datentyps int < 4 Bytes. Programm wird beendet" << endl;
   return 0;
  }
   else
   cout << "Länge des Datentyps int = 4 Bytes. Programm kann benztzt werden." << endl;
do
switch(wohin)
{
  default:
    taurus.Hauptmenue();
    cout << "\n\nIhre Wahl: ";
    cin >> wohin;
    if ((wohin < 0) && (wohin > 9)) wohin = 12;
   break;

  case 0:
    cout << "Ende Programm" << endl;
    return 0;
   break;

case 1:
    // Verschlüsselungstiefe auswählen
    taurus.setToprange();
    wohin = 12;
   break;

case 2:
     cout << "\nGeneriere Zufallszahlen";
     /** Initialisiere Arreale */
     taurus.SetRandomValues();   // Generiert das Zufallszahlenarreal
     clpuf(); // Lösche Tastaturpuffer
     iskeyfile = taurus.setiskeyfile(1); // Setzt den Wert der Variable iskeyfile auf 1
     /** Nach der Permutration des Zufallszahlenarreals wird dieses sofort auf Vollständigkeit getestet */
     taurus.testeareal();
     wohin = 12;
   break;

case 3:
    cout << "Schlüsselzahlen abspeichern" << endl;
    taurus.SaveKeyFile(); // Schreibt Zufallszahlenarry in eine Datei. Variable iskeyfile wird dabei auf 2 gesetzt
    wohin = 12;
   break;

case 4:
    // Schlüsselzahlen zeigen
    taurus.zeigearreal();
    wohin = 12;
   break;

case 5:
    // Schlüsselzahlen einlesen
    erge = taurus.RedKeyFileIn(); // Liest Schlüsselzahlenarry von einer Datei ein. Variable istkeyfile wird dabei auf 3 gesetzt
    if (erge == -1)
     cout << "Fehler bei öffenen der Datei" << endl;
    wohin = 12;
  break;

case 6:
     // Modifizieren der zu kodenden Datei
     cout << "\nDateilänge ermitteln\n";
     cout << "\nBitte Dateiname eingeben: ";
     taurus.getdatname(0);      // Speichert Dateinamen in Variable datname
     taurus.GetDatValues(0);    // Ermittelt ist-Lände der Quelldatei und verändert diese wenn nötig
     wohin = 12;
  break;

case 7: cout << "\n\nSRC-Datei einlesen";
           iskeyfile = taurus.getiskeyfile();
           if (iskeyfile < 2)
           {
            cout << "\nKeine Schlüsseldatei abgespeichert oder geladen ";
            wohin = 12;
            break;
           }
           taurus.KodierFrage();    // Frage ob kodiert oder dekodiert werden soll
           taurus.getfilnames(0);   // Liest den Namen der Quell- und Zieldatei ein
           taurus.getdatlen(0);     // Ermittelt die Dateilänge der Datei datname
           taurus.loadSRCDatei();   // Kodiert die Quelldatei zur Zieldatei
   wohin = 12;
  break;

case 8: cout << "Datei kodieren" << endl;
        kfilen = taurus.RedKeyFileIn(); // Liest Schlüsselzahlenarry von einer Datei (keyfilename) ein. Variable istkeyfile wird dabei auf 3 gesetzt
        if (kfilen == -1)
         {
          cout << "Keine Schlüsseldatei diese Namens vorhanden." << endl;
          cout << "Bitte zuerst Verschlüsselungstiefe wählen." << endl;
          cout << "Jetzt wählen: Bei Weiter Ja = 1 ,  Nein = 0 eingeben." << endl;
          cin  >> ausis;
          if ((ausis < 0) || (ausis > 1))
           {
            cout << "Fehlerhafte Eingabe: " << ausis << endl;
            break;
           }
          if (ausis ==  0)
           {
            cout << "Beende Datei kodieren" << ausis << endl;
            wohin = 12;
            break;
           }
          if (ausis ==  1)
           {
            cout << "Verschlüsselungstiefe wählen" << ausis << endl;
            taurus.setToprange();
           }
           cout << "Generiere Zufallszahlen" << endl;
           taurus.SetRandomValues();   // Generiert das Zufallszahlenarreal
           iskeyfile = taurus.setiskeyfile(1); // Setzt den Wert der Variable iskeyfile auf 1
           /** Nach der Permutation des Zufallszahlenarreals wird dieses sofort auf Vollständigkeit getestet */
           cout << "Teste Zufallszahlenarreal" << endl;
           taurus.testeareal();
           cout << "Speichere Schlüsselzahlen ab" << endl;
           taurus.SaveKeyFile();
         }
        cout << endl << "Modifizieren der zu kodierenden Datei" << endl;
        cout << "\nBitte Dateiname eingeben: ";
        taurus.getdatname(1);   // Liest Dateiname in Variable datname ein
        taurus.CopyfromDatname(taurus.quelldatei); // Kopiert die Variable datname nach quelldatei
        kfilen = taurus.GetDatValues(0);           // modifiziert die zu verschlüsselnde Datei
        if (kfilen == 0L)
         {
          cout << "Keine Quelldatei diese Namens vorhanden" << endl;
          break;
         }
        taurus.kodieren =  0;   // Kodieren = 0    dekodieren = 1
        ausis = taurus.getfilnames(1);  // Liest den Namen der Zieldatei ein
        if (ausis == 0)
         {
          wohin = 12;
          break;
         }
        taurus.getdatlen(1);    // Ermittelt die Dateilänge der Datei datname
        taurus.loadSRCDatei();  // Kodiert die Quelldatei zur Zieldatei
   wohin = 12;
 break;


case 9:
   /** Datei dekodieren */
   cout << "Datei dekodieren" << endl;
   ausis = taurus.getfilnames(0);  //Abfrage Name Quell- und Zieldatei
   if (ausis == 0)
    {
     wohin = 12;
     break;
    }
   taurus.RedKeyFileIn();   //Mit Abfrage des Schlüsseldateinames. Beinhaltet Funktion keyfiletest, diese wiederum GetOrgDatlen
   //cout << "Vorbereiten der zu dekodierenden Datei" << endl;
   //cout << "Bitte nicht mit Orginaldatei arbeiten. Datei wird zur Dekodierung veraendert!" << endl;
   //cout << "Bitte Name der zu dekodierenden Datei eingeben: " << endl;
   //taurus.getdatname();      // Abspeichern des Dateinamens in datname
   //taurus.GetDatValues();    // Errechnen der fehlenden Bytes für Kodiervorgang

   cout << endl << "Einlesen der Schlüsseldatei " << taurus.keyfilename << endl;
   iskeyfile = taurus.getiskeyfile();
   if (iskeyfile < 2)
    {
     cout << "\nKeine Schlüsseldatei abgespeichert oder geladen ";
     wohin = 12;
     break;
    }

    taurus.kodieren =  1;
    cout << "Dekodiere Datei " << taurus.quelldatei << "  zu   "  << taurus.zieldatei << endl;

   //taurus.getdatlen(0);  // Bei Parameter 1 = 0: ermittelt die Dateilänge von datname
   taurus.loadSRCDatei();
   wohin = 12;
  break;
/*
case 10:
taurus.getdatname(0);   // Liest Dateiname in Variable datname ein
taurus.CopyfromDatname(taurus.quelldatei);
cout << "Dateiname: " << taurus.quelldatei << endl;
wohin = 12;
break;
*/
case 10:
   cout << "Übertrage eingelesenes Schlüsselarreal nach Urarray zum neuen Permutieren" << endl;
   if (iskeyfile != 3)
    {
     cout << "Es wurde keine Schlüsseldate eingelesen" << endl;
     wohin = 12;
     break;
    }

   cout << "Übertragen ja = 1  nein = 0: " << endl;
   cin >> wohin;
   if ((wohin < 0) && (wohin > 1)) wohin = 0;
   if (wohin == 1)
    {
     for (mslei = 0; mslei < taurus.toprange; mslei++)
      {
       taurus.wuerfel[mslei] = taurus.schluessel[mslei];
      }
    }
    cout << "Eingelesene Werte: " << taurus.toprange << endl;
    cout << "Teste das eingelesene Ur-Arreal...." << endl;

    dummy = 0;
    erge = 0L;

    for (mslei = 0; mslei < taurus.toprange; mslei++)
     {
      dummy += mslei;
      erge += taurus.wuerfel[mslei];
     }
    cout << endl << "Anzahl: "<< taurus.toprange << " Ur-Arreal: " << erge << "  Testwert: " << dummy << endl;
   wohin = 12;
  break;


}
while(wohin != 0);

return 0;
}

/******************* Ende des Hauptprogramms ******************/


